# # coding: utf-8
#
# from django.contrib.auth.models import User
# from django.conf import settings
# from django.db.models.signals import pre_save
#
# from acomea.profilo.models import RichiestaAttivazioneCliente, AcomeaProfilo
#
# from .utils.sso_client import SSOClient
#
#
# def create_update_from_user(sender, **kwargs):
#     user = kwargs['instance']
#
#     sso_client = SSOClient()
#
#     if not user.id:
#         payload = {
#             "username": user.username,
#             "password": user.password,
#             "ar": "L",
#             "g5": "L",
#             "cn": user.first_name,
#             "sn": user.last_name,
#             "mail": user.email,
#             "srcSys": settings.ACOMEA_SSO_OAUTH["SRC_SYS"]
#         }
#         response = sso_client.insert(payload)
#         if response.status_code == 200:
#             user.save()
#         else:
#             raise Exception('{}: {}'.format(response.status_code, response.json()['message']))
#
#     else:
#         payload = {
#             "username": user.username,
#             "cn": user.first_name,
#             "sn": user.last_name,
#             "mail": user.email,
#             "srcSys": settings.ACOMEA_SSO_OAUTH["SRC_SYS"]
#         }
#         response = sso_client.update(payload)
#
#         if response.status_code == 200:
#             user.save()
#         else:
#             raise Exception('{}: {}'.format(response.status_code, response.json()['message']))
#
#
# def set_password_from_user(sender, **kwargs):
#     user = kwargs['instance']
#     if user.id:
#         old_password = User.objects.get(id=user.id).password
#         if old_password != user.password:
#             sso_client = SSOClient()
#
#             payload = {
#                 "username": user.username,
#                 "password": user.password,
#                 "srcSys": settings.ACOMEA_SSO_OAUTH["SRC_SYS"]
#             }
#             response = sso_client.set_password(payload)
#             if response.status_code == 200:
#                 user.save()
#             else:
#                 raise Exception('{}: {}'.format(response.status_code, response.json()['message']))
#
#
# def update_from_profile(sender, **kwargs):
#     profile = kwargs['instance']
#
#     sso_client = SSOClient()
#     payload = {
#         "username": profile.user.username,
#         "ar": 'C' if profile.is_cliente else 'L',
#         "g5": 'C' if profile.is_cliente else 'L',
#         "accTrattamentoDatiInt": "1" if profile.auth_trattamento_dati else "0",
#         "srcSys": settings.ACOMEA_SSO_OAUTH["SRC_SYS"]
#     }
#     response = sso_client.update(payload)
#     if response.status_code == 200:
#         profile.save()
#     else:
#         raise Exception('{}: {}'.format(response.status_code, response.json()['message']))
#
#
# def update_from_rac(sender, **kwargs):
#     rac = kwargs['instance']
#
#     sso_client = SSOClient()
#     payload = {
#         "username": rac.profile.user.username,
#         "cf": rac.codice_fiscale,
#         "srcSys": settings.ACOMEA_SSO_OAUTH["SRC_SYS"]
#     }
#
#     response = sso_client.update(payload)
#     if response.status_code == 200:
#         rac.save()
#     else:
#         raise Exception('{}: {}'.format(response.status_code, response.json()['message']))
#
#
# # if settings.ACOMEA_SSO_SERVER:
# #     pre_save.connect(create_update_from_user, User)
# #     pre_save.connect(update_from_profile, AcomeaProfilo)
# #     pre_save.connect(update_from_rac, RichiestaAttivazioneCliente)
#
